#include <iostream>
#include "RdmaClientEndpointGroup.hpp"
#include "MessageFormats.hpp"
int main()
{

    RdmaClientEndpointGroup *group = new RdmaClientEndpointGroup(5, 5, 5, 50, 50, 0, 1000);
    RdmaClientEndpoint *clientEp = group->createEndpoint();
    clientEp->connect("192.168.200.20", "1921", "sal");
    while (!clientEp->isConnected());
    std::cout << "client : connected" << std::endl;

    char *message = new char[30];
    struct SalRequestHeader *request = (struct SalRequestHeader *)message;
    request->id = clientEp->_requestId.fetch_add(1, std::memory_order_relaxed);
    request->type = RequestType::DELETE;
    request->keySize = 14;
    memcpy((char *)request + SalRequestHeaderSize, "key1sendkey1s", 13);
    ((char*)request)[SalRequestHeaderSize+14] = '\0';
    std::cout << "send Request for atomic int " << request->id << "\n";

    //   memcpy(re->value,"aa",2);

    std::cout << "send" << clientEp->sendMessage(message, SalRequestHeaderSize + 14) << std::endl;
    // std::cout << "send" << clientEp->sendMessage((char*)re, SalRequestHeaderSize + 2) << std::endl;
    std::cout << "send" << clientEp->sendMessage(message, SalRequestHeaderSize + 14) << std::endl;
    std::cout << "send" << clientEp->sendMessage(message, SalRequestHeaderSize + 14) << std::endl;
    std::cout << "send" << clientEp->sendMessage(message, SalRequestHeaderSize + 14) << std::endl;
    std::cout << "send" << clientEp->sendMessage(message, SalRequestHeaderSize + 14) << std::endl;
    std::cout << "send" << clientEp->sendMessage(message, SalRequestHeaderSize + 14) << std::endl;
    std::cout << "send" << clientEp->sendMessage(message, SalRequestHeaderSize + 14) << std::endl;
    std::cout << "send" << clientEp->sendMessage(message, SalRequestHeaderSize + 14) << std::endl;
    int send = 0;
    while (1)
    {
        std::cin >> send;
        if (send == 1)
        {
            std::cout << "send" << clientEp->sendMessage(message, 10) << std::endl;
        }
    }
}